#!/usr/bin/python

# lognews: A utility to grab Usenet article headers from a NNTP server
# and log them to a database.
# 
# Copyright (c) Rayner Lucas 2004, 2010.
#
# This file is part of lognews.
#
# lognews is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# lognews is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with lognews.  If not, see <http://www.gnu.org/licenses/>.


# This is a small launcher script. newsdaemon.py handles
# loading and saving the program's state, while newscollector.py
# handles all interactions with the news server and database.

import signal, sys, time
import newscollector
import newsdaemon

nd = newsdaemon.NewsDaemon()

# signal_handler: trap external signals sent to the program.
#
# Signals currently handled are:
# SIGTERM: Call exit function in newsdaemon, then exit successfully.
# SIGINT: Call exit function in newsdaemon, then exit successfully.
def signal_handler(signal, frame):
	print 'SIGINT or SIGTERM caught by lognews, exiting...'
	nd.cleanup()
	sys.exit(0)


###### Main program ######

# Set up signal handling for SIGINT and SIGTERM
signal.signal(signal.SIGINT, signal_handler)
signal.signal(signal.SIGTERM, signal_handler)

# Finally, set the daemon running.
nd.start()

