

CREATE TABLE TIMEZONE (
	OFFSET		INTEGER		NOT NULL,
		PRIMARY KEY(OFFSET)
);


CREATE TABLE ARTICLE (
	ARTICLEID			INTEGER		NOT NULL AUTO_INCREMENT,
	MESSAGEID			VARCHAR(255),
	ARTICLEFROM			VARCHAR(255),
	ARTICLEDATE			TIMESTAMP,
	DATETZ				INTEGER,
	SUBJECT				VARCHAR(255),
	EXPIRES				TIMESTAMP,
	EXPTZ				INTEGER,
	REPLYTO				VARCHAR(255),
	SENDER				VARCHAR(255),
	CONTROL				VARCHAR(255),
	APPROVED			VARCHAR(255),
	NUMLINES			INTEGER,
	ORGANIZATION		VARCHAR(255),
	SIZE				INTEGER,
	NNTPPOSTINGHOST		VARCHAR(255),
		PRIMARY KEY(ARTICLEID),
		FOREIGN KEY FKTZ(DATETZ) REFERENCES TIMEZONE ON DELETE RESTRICT,
		FOREIGN KEY FKEXPTZ(EXPTZ) REFERENCES TIMEZONE ON DELETE RESTRICT
);


CREATE TABLE REFERENCE (
	REFERENCER			INTEGER			NOT NULL,
	REFERENCED			VARCHAR(255)	NOT NULL,
		PRIMARY KEY(REFERENCER, REFERENCED),
		FOREIGN KEY FKREFR(REFERENCER) REFERENCES ARTICLE ON DELETE RESTRICT,
		FOREIGN KEY FKREFD(REFERENCED) REFERENCES ARTICLE
);


CREATE TABLE NEWSGROUP (
	GROUPNAME			VARCHAR(255)	NOT NULL,
		PRIMARY KEY(GROUPNAME)
);


CREATE TABLE NEWSGROUPARTICLE (
	ARTICLEID			INTEGER			NOT NULL,
	GROUPNAME			VARCHAR(255)	NOT NULL,
		PRIMARY KEY(ARTICLEID, GROUPNAME),
		FOREIGN KEY FKARTID(ARTICLEID) REFERENCES ARTICLE ON DELETE RESTRICT,
		FOREIGN KEY FKGROUP(GROUPNAME) REFERENCES NEWSGROUP ON DELETE RESTRICT
);


CREATE TABLE FOLLOWUPNEWSGROUP (
	ARTICLEID			INTEGER			NOT NULL,
	GROUPNAME			VARCHAR(255)	NOT NULL,
		PRIMARY KEY(ARTICLEID, GROUPNAME),
		FOREIGN KEY FKARTID(ARTICLEID) REFERENCES ARTICLE ON DELETE RESTRICT,
		FOREIGN KEY FKGROUP(GROUPNAME) REFERENCES NEWSGROUP ON DELETE RESTRICT
);


CREATE TABLE DISTRIBUTION (
	DISTRIBUTIONNAME	VARCHAR(255)	NOT NULL,
		PRIMARY KEY(DISTRIBUTIONNAME)
);


CREATE TABLE ARTICLEDISTRIBUTION (
	ARTICLEID			INTEGER			NOT NULL,
	DISTRIBUTIONNAME	VARCHAR(255)	NOT NULL,
		PRIMARY KEY(ARTICLEID, DISTRIBUTIONNAME),
		FOREIGN KEY FKARTID(ARTICLEID) REFERENCES ARTICLE ON DELETE RESTRICT,
		FOREIGN KEY FKDISTRIB(DISTRIBUTIONNAME) REFERENCES DISTRIBUTION ON DELETE RESTRICT
);


CREATE TABLE NEWSSERVER (
	SERVERNAME			VARCHAR(255)	NOT NULL,
		PRIMARY KEY(SERVERNAME)
);


CREATE TABLE NEWSSERVERARTICLE (
	ARTICLEID			INTEGER			NOT NULL,
	SERVERNAME			VARCHAR(255)	NOT NULL,
	HOPCOUNT			SMALLINT		NOT NULL,
		PRIMARY KEY(ARTICLEID, SERVERNAME, HOPCOUNT),
		FOREIGN KEY FKARTID(ARTICLEID) REFERENCES ARTICLE ON DELETE RESTRICT,
		FOREIGN KEY FKSERVER(SERVERNAME) REFERENCES NEWSSERVER ON DELETE RESTRICT
);
